#Jabber protocol module for SDBA Revolution IM Application Server

use Net::Jabber qw(Client);

#Create a new Net-Jabber client.
$SIG{HUP} = \&Stop;
$SIG{KILL} = \&Stop;
$SIG{TERM} = \&Stop;
$SIG{INT} = \&Stop;

my $Connection = new Net::Jabber::Client();

#To connect - called from sdba.pl
sub imconnect {
	$screenname = shift;
	$password = shift;
	$JabberServer = shift;
	$JabberPort = shift;
	$JabberResource = "SDBARevolution";


	$Connection->SetXPathCallBacks('/message'=>\&sdba_imin,
				       '/presence'=>\&Jabber_InPresence,
				       '/iq'=>\&Jabber_InIQ);

	my $status = $Connection->Connect(hostname=>$JabberServer,
					  port=>$JabberPort);

	if (!(defined($status)))
	{
	    print "ERROR:  Jabber server is down or connection was not allowed.\n";
	    print "        ($!)\n";
	    exit(0);
	}

	my @result = $Connection->AuthSend(username=>$screenname,
					   password=>$password,
					   resource=>$JabberResource);

	if ($result[0] ne "ok")
	{
	    print "ERROR: Authorization failed: $result[0] - $result[1]\n";
	    exit(0);
	}

	print "Logged in to $JabberServer:$JabberPort...\n";
	$Connection->RosterGet();
	
	print "Getting Roster to tell server to send presence info...\n";
	$Connection->PresenceSend();
}

#To start the loop, whatever it is - called from sdba.pl
sub imcont {
	while(defined($Connection->Process())) { }
}

sub Stop
{
    print "Exiting...\n";
    $Connection->Disconnect();
    exit(0);
}


#individual handlers
sub sdba_imin {

	my $sid = shift;
	my $message = shift;

	my $type = $message->GetType();
	my $fromJID = $message->GetFrom("jid");

	my $victim = $fromJID->GetUserID();
	my $server = $fromJID->GetServer();	
	my $resource = $fromJID->GetResource();
	my $subject = $message->GetSubject();
	my $msg = $message->GetBody();	
	#this is what comes in here
	#($aim, $evt, $from, $to) = @_;
	#$args = $evt->args();
	#($victim, $friend, $msg) = @$args;
	$victim = "$victim\@$server";
	
	on_im($victim, $screenname, $msg, $message);
}


sub RSEND_IM {
	#$vistim, $reply
	($victim, $reply, $screenname, $msg, $message) = @_;
	log_im($victim,$msg,$screenname,$reply);

	SEND_IM ($victim, $reply, $message);
}

sub SEND_IM {
	#$vistim, $reply
	($victim, $reply, $message) = @_;
	#Sleep before sending.
	#Queue em up
	#Max for AIM is 1024, so take a little off for the page #
	my $maxlen = $MaxMessageSize;
	my $lstr = "";	#just for slicing the string
	my @q;		#queue array
	my $i = 1;
	my $thread = $message->GetThread();
	#print "thread = $thread\n*************\n**************\n***********";
	while (length($reply) > $maxlen){
		$lstr = substr($reply,0,$maxlen);
		$reply = substr($reply,$maxlen-length($reply));
		push (@q, $lstr);
	}
	$h = $#q;
	$h = $h+2;  #number of total messages this is split into
	foreach $reply (@q){
		#header for extra-long messages
		$reply = "$i of $h\n".$reply;
		sleep(dosleep(1,3));
		$Connection->MessageSend(TO=>"$victim",
		BoDy=>"$reply",
		thread=>"$thread");
		$i++;
	}

	#sleep to avoid getting kicked for flooding
	#rest or message, for a normal message goes straight to this
	sleep(dosleep(1,3));
	$Connection->MessageSend(TO=>$victim,
	BoDy=>"$reply",
	thread=>"$thread");
}

sub Jabber_InPresence
{
    my $sid = shift;
    my $presence = shift;
    
    my $from = $presence->GetFrom();
    my $type = $presence->GetType();
    my $status = $presence->GetStatus();
    print "===\n";
    print "Presence\n";
    print "  From $from\n";
    print "  Type: $type\n";
    print "  Status: $status\n";
    print "===\n";
    print $presence->GetXML(),"\n";
    print "===\n";
}

sub Jabber_InIQ
{
    my $sid = shift;
    my $iq = shift;
    
    my $from = $iq->GetFrom();
    my $type = $iq->GetType();
    my $query = $iq->GetQuery();
    my $xmlns = $query->GetXMLNS();
    print "===\n";
    print "IQ\n";
    print "  From $from\n";
    print "  Type: $type\n";
    print "  XMLNS: $xmlns";
    print "===\n";
    print $iq->GetXML(),"\n";
    print "===\n";
}
1;